// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIMenuController.hpp"
#include "UISimpleMenuItem.hpp"

namespace Dawn {
  class UISimpleMenu : public SceneItemComponent {
    protected:
      UIMenuController *menu = nullptr;
      UICanvas *canvas = nullptr;
      UISimpleMenuItem *currentlySelected = nullptr;
      std::vector<UISimpleMenuItem*> menuItems;

    public:
      UISimpleMenu(SceneItem *item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}